


#include "main.h"

#include "LowPower.h"

#include <stdarg.h>




const int mode_slowspeed=8; // mode_slowspeed * 8 seconds - was 4
const int mode_switch=100; // after mode_count equals this switch to slow mode
int mode_speed=1;  // bigger == slower
int mode_count=0;
int mode_slow=0;     // true when in slow mode

const int mode_distance_count_slow=225; // every 30 mins
int mode_distance=3;
int mode_distance_count=4; // every 32 seconds




// https://code.google.com/p/tinkerit/wiki/SecretThermometer

long readTemp() {
  long result;
  // Read temperature sensor against 1.1V reference
  ADMUX = _BV(REFS1) | _BV(REFS0) | _BV(MUX3);
  delay(2); // Wait for Vref to settle
  ADCSRA |= _BV(ADSC); // Convert
  while (bit_is_set(ADCSRA,ADSC));
  result = ADCL;
  result |= ADCH<<8;
  result = (result - 125) * 1075;
  return result;
}


// https://code.google.com/p/tinkerit/wiki/SecretVoltmeter

long readVcc() {
  long result;
  // Read 1.1V reference against AVcc
  ADMUX = _BV(REFS0) | _BV(MUX3) | _BV(MUX2) | _BV(MUX1);
  delay(2); // Wait for Vref to settle
  ADCSRA |= _BV(ADSC); // Convert
  while (bit_is_set(ADCSRA,ADSC));
  result = ADCL;
  result |= ADCH<<8;
  result = 1126400L / result; // Back-calculate AVcc in mV

  ADMUX=0;

  return result;
}









/*******************************************************************************************/


// voltage 2 5.2
// temp    2 10.0
// hum     2 66
// freq    4
// 3,4,5,6,7 == 10 nybbles


void payload(void)
{
 long vcc=readVcc()/100;

 writevcc(vcc);

 if(mode_distance>=mode_distance_count)
 {
  read_distance();
  mode_distance=0;
 }
 else
 {
  mode_distance++;
 }

 transmitter_send();

 read_temp();

 if(!mode_slow)
 {
  digitalWrite(pin_led, HIGH);
  delay(100); 
  digitalWrite(pin_led, LOW);

  if(mode_count++==mode_switch)
  {
   mode_speed=mode_slowspeed;
   mode_slow=1;
   mode_distance_count=mode_distance_count_slow;
  }
 }
}  



void power_down(void)
{

  
}

void power_up(void)
{
 powerup_temp();
 transmitter_setup();
}





void autoloop() 
{
 int i; 

 power_down();

 for(i=0;i<mode_speed;i++)
 {
  LowPower.powerDown(SLEEP_8S, ADC_OFF, BOD_OFF);
 }
 
 power_up();

 payload();
}
